
package de.ivu.elect.business.datei.boundary;

import javax.enterprise.context.RequestScoped;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;

import de.ivu.elect.business.datei.entity.Datei;

@RequestScoped
@Named(DateiConversationSelect.COMPONENT_NAME)
public class DateiConversationSelect implements java.io.Serializable {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "dateiConversationSelect";

  @Inject
  protected transient DateiExtendedDAO entityDAO;

  @Inject
  @ConversationGroup(DateiConversationStore.class)
  protected transient DateiConversationStore conversationStore;

  public DateiConversationSelect() {
    super();
  }

  public boolean isSelected() {
    return getEntityPK() != null;
  }

  public Datei getEntity() {
    return getEntityInternal();
  }

  private Datei getEntityInternal() {
    if (getEntityPK() == null) {
      return null;
    }

    return attach(getEntityPK());
  }

  public void setEntity(Datei entity) {
    setEntityAttached(attach(entity));
  }

  public void setEntity( de.ivu.elect.business.datei.entity.DateiPK  pk) {
    setEntityAttached(attach(pk));
  }

  protected void setEntityAttached(Datei entity) {
    if(entity == null) {
      setEntityPK(null);
    } else {
      setEntityPK(entity.getPk());
    }
  }

  public
    de.ivu.elect.business.datei.entity.DateiPK
   getEntityPK() {
    return conversationStore.getEntityPK();
  }

  public void setEntityPK(
    de.ivu.elect.business.datei.entity.DateiPK
   entityPK) {
    conversationStore.setEntityPK(entityPK);
  }

  protected Datei attach(Datei entity) {
    if (entity == null){
      return null;
    }

    return attach(entity.getPk());
  }

  protected Datei attach( de.ivu.elect.business.datei.entity.DateiPK  pk) {
    if (pk == null) {
      return null;
    }

    return entityDAO.findByPrimaryKey(pk);
  }

  public void clearEntity() {
    setEntityPK(null);

    conversationStore.close();
  }
}
